<a href='https://github.com/angular/angular.js/edit/master/src/ng/directive/input.js?message=docs(input[email])%3A%20describe%20your%20change...#L869' class='improve-docs btn btn-primary'><i class="glyphicon glyphicon-edit">&nbsp;</i>Improve this Doc</a>



<a href='https://github.com/angular/angular.js/tree/master/src/ng/directive/input.js#L869' class='view-source pull-right btn btn-primary'>
  <i class="glyphicon glyphicon-zoom-in">&nbsp;</i>View Source
</a>


<header class="api-profile-header">
  <h1 class="api-profile-header-heading">input[email]</h1>
  <ol class="api-profile-header-structure naked-list step-list">
    
    <li>
      - input in module <a href="api/ng">ng</a>
    </li>
  </ol>
</header>



<div class="api-profile-description">
  <p>Text input with email validation. Sets the <code>email</code> validation error key if not a valid email
address.</p>
<div class="alert alert-warning">
<strong>Note:</strong> <code>input[email]</code> uses a regex to validate email addresses that is derived from the regex
used in Chromium. If you need stricter validation (e.g. requiring a top-level domain), you can
use <code>ng-pattern</code> or modify the built-in validators (see the <a href="guide/forms">Forms guide</a>)
</div>
</div>




<div>
  

  
  <h2>Directive Info</h2>
  <ul>
    
    <li>This directive executes at priority level 0.</li>
    
  </ul>

  
  <h2>Usage</h2>
  <pre><code>&lt;input type=&quot;email&quot;&#10;       ng-model=&quot;string&quot;&#10;       [name=&quot;string&quot;]&#10;       [required=&quot;string&quot;]&#10;       [ng-required=&quot;string&quot;]&#10;       [ng-minlength=&quot;number&quot;]&#10;       [ng-maxlength=&quot;number&quot;]&#10;       [pattern=&quot;string&quot;]&#10;       [ng-pattern=&quot;string&quot;]&#10;       [ng-change=&quot;string&quot;]&gt;</code></pre>

<section class="api-section">
  <h3>Arguments</h3>

<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        ngModel
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Assignable angular expression to data-bind to.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        name
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Property name of the form under which the control is published.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        required
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Sets <code>required</code> validation error key if the value is not entered.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        ngRequired
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Adds <code>required</code> attribute and <code>required</code> validation constraint to
   the element when the ngRequired expression evaluates to true. Use <code>ngRequired</code> instead of
   <code>required</code> when you want to data-bind to the <code>required</code> attribute.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        ngMinlength
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-number">number</a>
      </td>
      <td>
        <p>Sets <code>minlength</code> validation error key if the value is shorter than
   minlength.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        ngMaxlength
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-number">number</a>
      </td>
      <td>
        <p>Sets <code>maxlength</code> validation error key if the value is longer than
   maxlength. Setting the attribute to a negative or non-numeric value, allows view values of
   any length.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        pattern
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Similar to <code>ngPattern</code> except that the attribute value is the actual string
   that contains the regular expression body that will be converted to a regular expression
   as in the ngPattern directive.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        ngPattern
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Sets <code>pattern</code> validation error key if the ngModel <a href="api/ng/type/ngModel.NgModelController#$viewValue">$viewValue</a>
   does not match a RegExp found by evaluating the Angular expression given in the attribute value.
   If the expression evaluates to a RegExp object, then this is used directly.
   If the expression evaluates to a string, then it will be converted to a RegExp
   after wrapping it in <code>^</code> and <code>$</code> characters. For instance, <code>&quot;abc&quot;</code> will be converted to
   <code>new RegExp(&#39;^abc$&#39;)</code>.<br />
   <strong>Note:</strong> Avoid using the <code>g</code> flag on the RegExp, as it will cause each successive search to
   start at the index of the last search&#39;s match, thus not taking the whole input value into
   account.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        ngChange
        
        <div><em>(optional)</em></div>
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>Angular expression to be executed when input changes due to user
   interaction with the input element.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

</section>
  


  
  <h2 id="example">Example</h2><p>

<div>
  <plnkr-opener example-path="examples/example-email-input-directive"></plnkr-opener>

  <div class="runnable-example"
      path="examples/example-email-input-directive"
      name="email-input-directive"
      module="emailExample">

  
    <div class="runnable-example-file" 
      name="index.html"
      language="html"
      type="html">
      <pre><code>&lt;script&gt;&#10;  angular.module(&#39;emailExample&#39;, [])&#10;    .controller(&#39;ExampleController&#39;, [&#39;$scope&#39;, function($scope) {&#10;      $scope.email = {&#10;        text: &#39;me@example.com&#39;&#10;      };&#10;    }]);&#10;&lt;/script&gt;&#10;  &lt;form name=&quot;myForm&quot; ng-controller=&quot;ExampleController&quot;&gt;&#10;    &lt;label&gt;Email:&#10;      &lt;input type=&quot;email&quot; name=&quot;input&quot; ng-model=&quot;email.text&quot; required&gt;&#10;    &lt;/label&gt;&#10;    &lt;div role=&quot;alert&quot;&gt;&#10;      &lt;span class=&quot;error&quot; ng-show=&quot;myForm.input.$error.required&quot;&gt;&#10;        Required!&lt;/span&gt;&#10;      &lt;span class=&quot;error&quot; ng-show=&quot;myForm.input.$error.email&quot;&gt;&#10;        Not valid email!&lt;/span&gt;&#10;    &lt;/div&gt;&#10;    &lt;tt&gt;text = {{email.text}}&lt;/tt&gt;&lt;br/&gt;&#10;    &lt;tt&gt;myForm.input.$valid = {{myForm.input.$valid}}&lt;/tt&gt;&lt;br/&gt;&#10;    &lt;tt&gt;myForm.input.$error = {{myForm.input.$error}}&lt;/tt&gt;&lt;br/&gt;&#10;    &lt;tt&gt;myForm.$valid = {{myForm.$valid}}&lt;/tt&gt;&lt;br/&gt;&#10;    &lt;tt&gt;myForm.$error.required = {{!!myForm.$error.required}}&lt;/tt&gt;&lt;br/&gt;&#10;    &lt;tt&gt;myForm.$error.email = {{!!myForm.$error.email}}&lt;/tt&gt;&lt;br/&gt;&#10;  &lt;/form&gt;</code></pre>
    </div>
  
    <div class="runnable-example-file" 
      name="protractor.js"
      type="protractor"
      language="js">
      <pre><code>var text = element(by.binding(&#39;email.text&#39;));&#10;var valid = element(by.binding(&#39;myForm.input.$valid&#39;));&#10;var input = element(by.model(&#39;email.text&#39;));&#10;&#10;it(&#39;should initialize to model&#39;, function() {&#10;  expect(text.getText()).toContain(&#39;me@example.com&#39;);&#10;  expect(valid.getText()).toContain(&#39;true&#39;);&#10;});&#10;&#10;it(&#39;should be invalid if empty&#39;, function() {&#10;  input.clear();&#10;  input.sendKeys(&#39;&#39;);&#10;  expect(text.getText()).toEqual(&#39;text =&#39;);&#10;  expect(valid.getText()).toContain(&#39;false&#39;);&#10;});&#10;&#10;it(&#39;should be invalid if not email&#39;, function() {&#10;  input.clear();&#10;  input.sendKeys(&#39;xxx&#39;);&#10;&#10;  expect(valid.getText()).toContain(&#39;false&#39;);&#10;});</code></pre>
    </div>
  

    <iframe class="runnable-example-frame" src="examples/example-email-input-directive/index.html" name="example-email-input-directive"></iframe>
  </div>
</div>


</p>

</div>


